# Code for paper Provable Benefits of Representational Transfer in Reinforcement Learning

## Prerequisites

Creating a virtual environment is recommended (or using conda alternatively):
```bash
pip install virtualenv
virtualenv /path/to/venv --python=python3

#To activate a virtualenv: 

. /path/to/venv/bin/activate
```

To install the dependencies (the results from the paper are obtain from gym==0.14.0):
``` bash
pip install -r requirements.txt
```

To install pytorch, please follow [PyTorch](http://pytorch.org/). Note that the current implementation does not require pytorch gpu.

We use [wandb](https://wandb.ai/home) to collect results, please setup wandb before running the code or add `os.environ['WANDB_MODE'] = 'offline'` in `*.py` files.

## Run our code

To reproduce our result in section 6.1 for G-RepTransfer, please run:
```bash
bash run.sh
```

To reproduce our result in section 6.1 for O-RepTransfer, please run:
```bash
bash run_online.sh
```

To reproduce our result in section 6.2 for G-RepTransfer, please run:
```bash
bash run_partition.sh
```

To reproduce our result in section 6.2 for )-RepTransfer, please run:
```bash
bash run_partition_online.sh
```

To see all the hyperparameters, please refer to `utils.py`.

